
/*********************************************************************
*                                                                    *
*  2MF.C  1.3  -  UTILIDAD DE FORMATEO DE DISQUETES PARA 2M          *
*                                                                    *
*                    (c) 1994 Ciriaco Garca de Celis.               *
*                                                                    *
*   - Para Borland C++ 2.0  superior en modelo de memoria LARGE.    *
*   - Este programa se compila abriendo un proyecto e introduciendo  *
*     en l 2MF.C y 2MFBOOT.OBJ (vase 2MFBOOT.ASM).                 *
*                                                                    *
*********************************************************************/

#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <time.h>

#define MAXFAT  6128  /* mayor tamao de FAT12 posible */
#define MAXSECT 23    /* mayor nmero de sectores por pista posible */

unsigned _stklen = 32768;  /* 32K de pila para MAXSECT*512*2 */

struct boot {                       /* sector arranque disquetes 2M */
  unsigned char Salto[3], IdSis[8];
  short    BytesSect;
  char     SectCluster;
  short    SectReserv;
  char     NumFats;
  short    FichRaiz, NumSect;
  char     MediaId;
  short    SectFat, SectPista, Caras;
  long     Especiales, Sect32;
  char     Unidad, Reservado, Flag;
  long     NumSerie;
  char     Titulo[11], TipoFat[8];
  char     NoUsado;
  char     CheckSum;
  char     VersionFmt, FlagWr, VelPista0, VelPistaX;
  short    OffsetJmp, OffsetPista0, OffsetPistaX, OffsetListaTam;
  char     Resto[512-76];
  };

struct parametros {              /* parmetros en lnea de comandos */
  int   Unidad, HD, TipoFmt,
        Pistas, FichRaiz, Silencioso, X, Y, G;
  };

int    HablaSp(), Hay2m(), FormatearDisco(), MarcaFat(), TipoDrive(),
       Format2m(), biosdsk(), InicializaDisco(), EsperarCambioDisco();
extern BootPrg,
       BootPrgLong;
void   Ayuda(), ProcesarParametros(), CrearSector0(), ResetDrive(),
       DiagnosticoError(), InformeError(), InformeDisco(),
       SonidoSube(), SonidoBaja(), SonidoError(), SonidoOn(),
       SonidoOff(), Sonido(), PicoRetardo();

int    sp;   /* 1-espaol 0-ingls */


void main (int argc, char **argv)
{
  struct boot sector0;
  struct parametros cmd;
  int    salir, result;
  long   bytes_err;

  sp=HablaSp();  /* determinar idioma del pas */

  ProcesarParametros (argc, argv, &cmd);

  if (!hay2m()) {
    if (sp)
        printf("  2M 1.3 no est instalado, imposible formatear.\n");
      else
        printf("  2M 1.3 is not installed, impossible to format.\n");
    exit(128);
    }

  if (sp)
      printf("  Pulsa una tecla para formatear en");
    else
      printf("  Press any key to format on");
  printf(" %c:", cmd.Unidad+'A');

  salir=getch()==27;
  while (!salir) {
    CrearSector0 (&sector0, cmd);
    if (!cmd.Silencioso) SonidoSube();
    switch (result=FormatearDisco (&sector0, &cmd, &bytes_err)) {
      case 0:  InformeDisco (&sector0, bytes_err);
               if (!cmd.Silencioso) SonidoBaja(); break;
      case 1:  DiagnosticoError (result);
               break;
      default: DiagnosticoError (result);
               if (!cmd.Silencioso) SonidoError(); break;
      }
    if (sp)
        printf("\n  Introduce otro disquete para formatear en");
      else
        printf("\n  Please introduce another disk to format on");
    printf(" %c:", cmd.Unidad+'A');

    if (!EsperarCambioDisco(cmd.Unidad)) salir=1;
    }
  printf("\r                                                     \r");
}


void ProcesarParametros(int argc, char **argv, struct parametros *cmd)
{
  int pm, error=0, hlp=0;

  if (argc<=1) hlp++;
  cmd->Unidad=cmd->TipoFmt=0; cmd->HD=1; cmd->Pistas=82;
  cmd->FichRaiz=cmd->Silencioso=0;
  cmd->X=cmd->Y=cmd->G=-1;
  for (pm=1; pm<argc; pm++) {
    strupr (argv[pm]);
    if (strstr(argv[pm],"/?")!=NULL) hlp++;
    else if (strstr(argv[pm],"/H")!=NULL) hlp++;
    else if ((strstr(argv[pm],"A:")!=NULL) ||
      (strstr(argv[pm],"B:")!=NULL)) cmd->Unidad=*argv[pm]-'A';
    else if (strstr(argv[pm],"/DD")!=NULL) cmd->HD=0;
    else if (strstr(argv[pm],"/F")!=NULL) cmd->TipoFmt=0;
    else if (strstr(argv[pm],"/M")!=NULL) cmd->TipoFmt=1;
    else if (strstr(argv[pm],"/T")!=NULL)
      cmd->Pistas = atoi (&argv[pm][3]);
    else if (strstr(argv[pm],"/R")!=NULL)
      cmd->FichRaiz = atoi (&argv[pm][3]);
    else if (strstr(argv[pm],"/S")!=NULL) cmd->Silencioso=1;
    else if (strstr(argv[pm],"/X")!=NULL) cmd->X=atoi(&argv[pm][3]);
    else if (strstr(argv[pm],"/Y")!=NULL) cmd->Y=atoi(&argv[pm][3]);
    else if (strstr(argv[pm],"/G")!=NULL) cmd->G=atoi(&argv[pm][3]);
    else if (strstr(argv[pm],"/I")!=NULL) sp^=1;
    else error=1;
    }

  if (hlp) Ayuda();

  if (sp)
      printf("\n2MF 1.3 - Utilidad de formateo para 2M\t\t[ESC Salir]\n");
    else
      printf("\n2MF 1.3 - Format utility program for 2M\t\t[ESC Aborts]\n");
  if (error) {
    if (sp)
        printf("  Error de sintaxis. Ejecute 2MF /?.\n");
      else
        printf("  Incorrect parameter(s). Execute 2MF /?.\n");
    exit (2);
    }
  if ((TipoDrive(cmd->Unidad)!=2) && (TipoDrive(cmd->Unidad)!=4)) {
    if (sp)
        printf("    La unidad indicada no existe o no es de alta densidad.\n");
      else
        printf("    Drive indicated does not exist or it isn't high density.\n");
    exit (2);
    }
  if ((cmd->Pistas<80) || (cmd->Pistas>89)) {
    if (sp)
        printf("  Error: Nmero de pistas incorrecto.\n");
      else
        printf("  Error: Incorrect number of tracks.\n");
    exit (2);
    }
  if (cmd->FichRaiz && ((cmd->FichRaiz<1) || (cmd->FichRaiz>240))) {
    if (sp)
        printf("  Error: N de ficheros en directorio raiz errneo.\n");
      else
        printf("  Error: Bad number of files in root directory.\n");
    exit (2);
    }
}


void Ayuda(void)
{
  if (sp) {
      printf("\n\n");
      printf("         2MF 1.3 - UTILIDAD ESTANDAR DE FORMATEO DE DISQUETES PARA 2M\n");
      printf("         \n");
      printf("                    (C) Enero 1994  Ciriaco Garca de Celis.\n");
      printf("     Grupo Universitario de Informtica  -  Apdo. 6062 Valladolid (Espaa).\n");
      printf("                        Internet Email: ciri@gui.uva.es\n\n");
      printf("        2MF U: [/DD] [/F|M] [/T=nn] [/R=nn] [/S] [/X=nn] [/Y=nn] [/G=nn]\n\n");
      printf("    Este programa formatea disquetes a una mayor capacidad y/o velocidad de la\n");
      printf("  normal. Para que estos nuevos disquetes funcionen debe estar instalado 2M en\n");
      printf("  memoria. Este programa es gratuto y de dominio pblico. Opciones:\n\n");
      printf("  /DD  Solicita un formateo en doble densidad -por defecto se hace en alta-.\n");
      printf("   /F  Disquetes rpidos y seguros -por defecto- (5:820-1476K, 3:984-1804K).\n");
      printf("   /M  Formatear disquetes a la mxima capacidad (5:902-1558K, 3:1066-1886K).\n\n");
      printf("   /T  Modificar el nmero de pistas por defecto (80-89).\n");
      printf("   /R  Modificar ficheros permitidos en directorio raz (1-240).\n");
      printf("   /S  Funcionamiento silencioso sin emitir sonido.\n\n");
      printf("   /X  Salto en numeracin de sectores al conmutar de cabezal en /F (no tocar).\n");
      printf("   /Y  Salto en numeracin de sectores al cambiar de cilindro en /F (no tocar).\n");
      printf("   /G  Valor de GAP en la opcin /F y del GAP virtual en /M (no tocar).\n");
      }
    else {
      printf("\n\n");
      printf("              2MF 1.3 - STANDARD FORMAT UTILITY FOR 2M DISKETTES\n");
      printf("         \n");
      printf("                   (C) January 1994  Ciriaco Garca de Celis.\n");
      printf("     Grupo Universitario de Informtica  -  Apdo. 6062 Valladolid (Spain).\n");
      printf("                        Internet Email: ciri@gui.uva.es\n\n");
      printf("        2MF U: [/DD] [/F|M] [/T=nn] [/R=nn] [/S] [/X=nn] [/Y=nn] [/G=nn]\n\n");
      printf("    This program formats diskettes at a higher capacity and/or speed than the\n");
      printf("  normal ones.  2M must be installed on memory to provide support for the new\n");
      printf("  diskettes. 2MF is a 100%% freeware utility. Meaning of switches:\n\n");
      printf("  /DD  Request a double-density format (by default it will be high-density).\n");
      printf("   /F  Fast and secure diskettes  -by default-  (5:820-1476K, 3:984-1804K).\n");
      printf("   /M  Formats diskettes up to maximum capacity (5:902-1558K, 3:1066-1886K).\n\n");
      printf("   /T  Sets the number of tracks to be used (80-89).\n");
      printf("   /R  Sets the number of root directory entries (1-240).\n");
      printf("   /S  Tells 2MF not to make sound effects.\n\n");
      printf("   /X  Sector sliding for side-to-side access in /F mode (do not change).\n");
      printf("   /Y  Sector sliding for tract-to-track access in /F mode (do not change).\n");
      printf("   /G  Value of GAP in /F mode and virtual GAP in /M mode (do not change).\n");
      }
  exit (1);
}


int hay2m()     /* devolver 1 si 2M est instalado */
{
  int entrada, instalado=0;
  union REGS r; struct SREGS s;

  for (entrada=0xc0; (entrada<=0xff) && (!instalado); entrada++) {
    r.x.ax=entrada << 8; s.es=0x1492; r.x.di=0x1992;
    int86x (0x2f, &r, &r, &s);
    if (r.x.ax==0xFFFF)
      if ((peek(s.es,r.x.di-4)==9002) && (peek(s.es,r.x.di-2)==10787))
        if (strstr (MK_FP(s.es, r.x.di),"2M:1.3")) instalado=1;
        if (strstr (MK_FP(s.es, r.x.di),"2MX:1.3")) instalado=1;
    }
  return (instalado);
}


void CrearSector0 (struct boot *s0, struct parametros cmd)
{
  unsigned  tipo, i, j, k, m, t, s, tam, ini, fin, inc;
  char id[8]="2M-STV00", ch, sum, far *p;
  static unsigned char infofis [2][2][2][4][20] =
  {{{{{10,176,6,0,1,1},       {9,80,1,1},            /* 5-DD  /F */
      {5,100,3,1,1},          {3}              },
     {{11,176,6,1,1,1},       {9,80,1,1},            /*        /M */
      {32,4,5,3,1,4,2,0},     {4,2,4,3,0}      }},
    {{{18,224,6,0,0,0},       {15,84,1,1},           /* 5-HD  /F */
      {9,50,3,1,2},           {3}              },
     {{19,224,6,1,0,0},       {15,84,1,1},           /*        /M */
      {53,3,6,4,1,5,2,6,3},   {4,4,2,4,4,3}    }}},
   {{{{12,192,6,0,2,1},       {9,80,1,1},            /* 3-DD  /F */
      {6,100,3,1,1},          {3}              },
     {{13,192,6,1,2,1},       {9,80,1,1},            /*        /M */
      {38,5,6,3,1,4,2,0,0},   {4,2,4,4,0,0}    }},
    {{{22,224,6,0,0,0},       {18,108,1,1},          /* 3-HD  /F */
      {11,40,3,1,2},          {3}              },
     {{23,224,6,1,0,0},       {18,108,1,1},          /*        /M */
      {64,3,7,4,1,5,2,6,3,7}, {4,4,4,4,4,3,2}  }}}};

  tipo = TipoDrive (cmd.Unidad) / 3;  /* 0-5, 1-3 */

  s0->Salto[0]=0xE9; s0->Salto[1]=s0->Salto[2]=s0->NoUsado=0;

  ch=1+cmd.HD;
  if (TipoDrive(cmd.Unidad)>2) ch+=2; if (!cmd.TipoFmt) ch+=4;
  id[7]=ch+'0'; strncpy (s0->IdSis, id, 8);

  s0->BytesSect=512;
  s0->SectCluster = s0->SectReserv = 1;  s0->NumFats=2;

  if (!cmd.FichRaiz)
      s0->FichRaiz=infofis[tipo][cmd.HD][cmd.TipoFmt][0][1];
    else
      if (cmd.FichRaiz % 16)
          s0->FichRaiz=((cmd.FichRaiz >> 4) + 1) << 4;
        else
          s0->FichRaiz=cmd.FichRaiz;
  s0->MediaId=0xF0;
  s0->SectPista=infofis[tipo][cmd.HD][cmd.TipoFmt][0][0];
  s0->Caras=2;
  s0->NumSect=cmd.Pistas*s0->Caras*s0->SectPista;

  i=(512L*(s0->NumSect - (s0->FichRaiz>>4) - 1) /
         (512L * s0->SectCluster + 3) + 2)*3;
  if (i % 1024) i=(i>>10)+1; else i>>=10;
  s0->SectFat=i;

  s0->Unidad = s0->Reservado = 0; s0->Especiales = s0->Sect32 = 0L;
  s0->Flag=0x29; randomize();
  for (i=0; i<4; i++)
    s0->NumSerie = (s0->NumSerie<<8) | (unsigned char) random(32767);

  strncpy (s0->Titulo, "NO NAME    ", 11);
  strncpy (s0->TipoFat, "FAT12   ", 8);

  s0->VersionFmt=infofis[tipo][cmd.HD][cmd.TipoFmt][0][2];
  s0->FlagWr=infofis[tipo][cmd.HD][cmd.TipoFmt][0][3];
  s0->VelPista0=infofis[tipo][cmd.HD][cmd.TipoFmt][0][4];
  s0->VelPistaX=infofis[tipo][cmd.HD][cmd.TipoFmt][0][5];

  tam=76; /* lo que precede a la primera tabla */
  s0->OffsetPista0=tam;
  s0->Resto[0]=infofis[tipo][cmd.HD][cmd.TipoFmt][1][0];
  s0->Resto[1]=infofis[tipo][cmd.HD][cmd.TipoFmt][1][1];
  ch=infofis[tipo][cmd.HD][cmd.TipoFmt][1][2];
  inc=infofis[tipo][cmd.HD][cmd.TipoFmt][1][3];
  ini=tam+2; fin=ini+s0->Resto[0]; k=0;
  for (i=j=0; j<s0->Resto[0]; j++) {
    s0->Salto[ini+i]=ch++; if (ch>s0->Resto[0]) ch=1;
    i+=inc; if (ini+i>=fin) i=++k;
    }

  ini=fin; s0->OffsetPistaX=ini;
  if (!s0->FlagWr) {
      k=infofis[tipo][cmd.HD][cmd.TipoFmt][2][0]; j=5;
      for (i=0; i<j; i++)
        s0->Salto[ini+i]=infofis[tipo][cmd.HD][cmd.TipoFmt][2][i];
      if (cmd.X!=-1) s0->Salto[ini+3]=cmd.X;
      if (cmd.Y!=-1) s0->Salto[ini+4]=cmd.Y;
      }
    else {
      k=infofis[tipo][cmd.HD][cmd.TipoFmt][2][2]; j=(k+1)*3;
      for (i=0; i<3; i++)
        s0->Salto[ini+i]=infofis[tipo][cmd.HD][cmd.TipoFmt][2][i];
      m=129;
      for (i=3; i<=k*3; i+=3) {
        s0->Salto[ini+i]=m;
        s=infofis[tipo][cmd.HD][cmd.TipoFmt][2][i/3+2];
        s0->Salto[ini+i+1]=s;
        t=infofis[tipo][cmd.HD][cmd.TipoFmt][3][s-1];
        switch (t) {
          case 0: m+=1;  break;   case 1: m+=2;  break;
          case 2: m+=3;  break;   case 3: m+=6;  break;
          case 4: m+=11; break;   case 5: m+=22; break;
          }
        s0->Salto[ini+i+2]=t;
        }
      }
  if (cmd.G!=-1) s0->Salto[ini+1]=cmd.G;
  fin=ini+j;

  ini=fin; s0->OffsetListaTam=ini;
  if (!s0->FlagWr)
      for (i=0; i<k; i++)
        s0->Salto[ini+i]=infofis[tipo][cmd.HD][cmd.TipoFmt][3][0];
    else
      for (i=0; i<k; i++)
        s0->Salto[ini+i]=infofis[tipo][cmd.HD][cmd.TipoFmt][3][i];
  fin=ini+k;

  ini=fin; s0->OffsetJmp=ini;
  s0->Salto[1]=(ini-3) % 256; s0->Salto[2]=(ini-3) >> 8;
  p=(char far *) &BootPrg;
  for (i=0; i<BootPrgLong; i++) s0->Salto[ini+i]=*p++;

  for (i+=ini; i<496; i++) s0->Salto[i]=0;
  strncpy (&s0->Salto[496], "Made in Spain", 13);
  s0->Salto[509]=0; s0->Salto[510]=0x55; s0->Salto[511]=0xAA;

  for (sum=0, j=64; j<ini; j++) sum+=s0->Salto[j]; /* checksum */
  s0->CheckSum=-sum;
}


int FormatearDisco (sector0, cmd, bytes_defectuosos)
struct boot *sector0;
struct parametros *cmd;
long *bytes_defectuosos;
{
  unsigned char fat [MAXFAT];
  unsigned char buf_io [MAXSECT << 10]; /* doble tamao por el DMA */
  unsigned char far *buf=buf_io;
  unsigned long dir;
  int      cilindros, cilindro, cabezal, intento, i, error=1, spista;
  unsigned long fase, fases;

  dir = ((unsigned long) FP_SEG(buf) <<4) + FP_OFF(buf);
  if ((dir >> 16) != ((dir + MAXSECT << 9) >> 16)) buf+=MAXSECT << 9;

  if (sp)
      printf("\r  Formateo de %dK en %c: (disquete ",
         sector0->NumSect>>1, cmd->Unidad+'A');
    else
      printf("\r  Formatting %dK on %c: (",
         sector0->NumSect>>1, cmd->Unidad+'A');

  switch (TipoDrive (cmd->Unidad)) {
    case 2:  printf("%s", cmd->HD?"5-1.2M":"5-360K"); break;
    default: printf("%s", cmd->HD?"3-1.44M":"3-720K");
    }
  if (sp)
      printf (")              \n");
    else
      printf (" diskette)     \n");

  for (i=0; i<MAXFAT; i++) fat[i]=0;  /* poner a 0 la futura FAT */
  fat[0]=sector0->MediaId; fat[1]=fat[2]=0xFF;

  cilindros=sector0->NumSect/(sector0->SectPista*sector0->Caras);
  spista=sector0->SectPista; *bytes_defectuosos=0L;
  fases=1L*cilindros*sector0->Caras*(2+sector0->FlagWr); fase=0L;

  for (cilindro=0; cilindro < cilindros; cilindro++)
    for (cabezal=0; cabezal<sector0->Caras; cabezal++) {
      for (intento=0; intento<3; intento++) {
        if (sp)
            printf("\r  Cilindro %2d - Cara %d  [F-]  %3lu%%",
                   cilindro, cabezal, fase*100/fases);
          else
            printf("\r  Cylinder %2d - Side %d  [F-]  %3lu%%",
                   cilindro, cabezal, fase*100/fases);
        if (error) ResetDrive (cmd->Unidad);
        error=1; while (kbhit()) if (getch()==27) goto FinFormat;
        error=Format2m (cmd->Unidad, cilindro, cabezal, sector0);
        if ((sector0->FlagWr==1) && !error) {
          printf ("\b\b\b\b\b\b\b\b\bI-]  %3lu%%",(fase+1)*100/fases);
          error=biosdsk (3, cmd->Unidad, cabezal,
                         cilindro, 1, spista, buf);
          }
        if (!error) {
          printf ("\b\b\b\b\b\b\b\b\b-V]  %3lu%%",
                 (fase+1+sector0->FlagWr)*100/fases);
          error=biosdsk (2, cmd->Unidad, cabezal,
                         cilindro, 1, spista, buf);
          }
        if (!error) break;
        }
      if (error)
        if ((error==128) || (error==3) || (error==6))
            goto FinFormat;   /* error fatal */
          else
            if (!MarcaFat(cmd->Unidad,sector0,cilindro,cabezal,fat,
              bytes_defectuosos))
              goto FinFormat; /* error en reas del sistema */
      fase+=(2+sector0->FlagWr);
      }

  printf ("\b\b\b\b\b\b\b\b\b--]  100%%");
  error=InicializaDisco (cmd->Unidad, sector0, fat);

  FinFormat: pokeb(0x40, 0x40, 1);  /* pronta detencin del motor */

  return (error);
}


void InformeDisco (struct boot *s0, long bd)
{
  unsigned long st, ua, bt;

  st = s0->NumSect - s0->NumFats * s0->SectFat
       - s0->SectReserv - (s0->FichRaiz>>4);
  ua = st / (unsigned long) s0->SectCluster;  bt = st*512L;

  if (sp) {
      printf ("\r  Volmen con nmero de serie %04X-%04X\n",
        (int) (s0->NumSerie >> 16), (int) s0->NumSerie);
      printf ("%9d ficheros permitidos en el raz.\n",
        s0->FichRaiz);
      printf ("%9d unidades de asignacin.\n", ua);
      printf ("%9d bytes por unidad de asignacin.\n",
        s0->SectCluster*512);
      printf ("%9lu bytes totales en el disco.\n", bt);
      printf ("%9lu bytes en sectores defectuosos.\n", bd);
      printf ("%9lu bytes disponibles en el disco.\n", bt-bd);
      }
    else {
      printf ("\r  Volume serial number is %04X-%04X\n",
        (int) (s0->NumSerie >> 16), (int) s0->NumSerie);
      printf ("%9d files can hold the root directory.\n",
        s0->FichRaiz);
      printf ("%9d total clusters on disk.\n", ua);
      printf ("%9d bytes per cluster.\n",
        s0->SectCluster*512);
      printf ("%9lu total bytes on disk.\n", bt);
      printf ("%9lu bytes on bad sectors.\n", bd);
      printf ("%9lu bytes available on disk.\n", bt-bd);
      }
}


void DiagnosticoError (int codigo)
{
  if (sp) {
      switch (codigo) {
        case 1:   printf("\r  Formateo interrumpido por el usuario.");
                  break;
        case 2:   printf("\r  La densidad seleccionada es incorrecta.");
                  break;
        case 3:   printf("\r  Disquete protegido contra escritura.");
                  break;
        case 6:
        case 128: printf("\r  Unidad no preparada (puerta abierta?).");
                  break;
        default:  printf("\r  Anomala general: densidad incorrecta?.");
                  break;
        }
      }
    else {
      switch (codigo) {
        case 1:   printf("\r  Format aborted by user.");
                  break;
        case 2:   printf("\r  Selected density is incorrect.");
                  break;
        case 3:   printf("\r  Diskette is write-protected.");
                  break;
        case 6:
        case 128: printf("\r  Drive not ready (door open?).");
                  break;
        default:  printf("\r  General failure: incorrect density?.");
                  break;
        }
      }
  printf("                                  \n");
}


int MarcaFat (unidad, sector0, cilindro, cabezal, fat, bytes_mal)
struct   boot *sector0;
int      unidad, cilindro, cabezal;
unsigned char far *fat;
long     *bytes_mal;
{
  unsigned char buffer[512];
  unsigned i, ini, tamsys;

  tamsys = sector0->NumFats*sector0->SectFat+(sector0->FichRaiz>>4)+1;

  for (i=1; i<=sector0->SectPista; i++) {
    ini=(cilindro*sector0->Caras+cabezal)*sector0->SectPista+i-1;
    if (biosdsk (2, unidad, cabezal, cilindro, i, 1, buffer)) {
      if (ini<tamsys) break;  /* error en reas del sistema */
      *bytes_mal+=sector0->SectCluster*512L;
      ini-=tamsys; ini=ini/sector0->SectCluster+2;
      if (ini % 2) { /* posicin impar */
          fat [ini*3/2] = fat [ini*3/2] & 0x0F | 0x70;
          fat [ini*3/2+1] = 0xFF;
          }
        else {       /* posicin par */
          fat [ini*3/2] = 0xF7;
          fat [ini*3/2+1] = fat [ini*3/2+1] & 0xF0 | 0x0F;
          }
      ini=0x7FFF;
      }
    }
  return (ini>=tamsys);
}


int TipoDrive (int unidad)
{
  union REGS r;

  r.h.ah=8; r.h.dl=unidad;
  r.x.si=0x324d; /* pedir informacin a 2MX si est residente */
  int86 (0x13, &r, &r);
  return ((unsigned char) r.h.bl);
}


Format2m (unidad, cilindro, cabezal, boot)
int unidad, cilindro, cabezal;
unsigned char far *boot;
{
  union REGS r; struct SREGS s;
  unsigned long i13;
  unsigned char result;
  unsigned segboot=FP_SEG(boot), offboot=FP_OFF(boot);

  r.x.ax=0x3513; intdosx (&r, &r, &s);
  i13=((unsigned long) s.es << 16) | r.x.bx;

  asm {
    mov  ax,57fh
    mov  ch,byte ptr cilindro   /* No se invoca la INT 13h porque */
    mov  dh,byte ptr cabezal    /* dentro de WINDOWS 3 se ejecuta */
    mov  dl,byte ptr unidad     /* cierto cdigo en modo protegido */
    mov  si,324dh               /* que hace fallar el formateo en */
    mov  bx,segboot             /* los modos de mxima capacidad. */
    mov  es,bx
    mov  bx,offboot
    pushf
    call dword ptr i13    /* llamar con CALL a INT 13h */
    mov  result,ah
    }

  return (result);   /* cdigo de error de la BIOS */
}


int biosdsk (int cmd, int drive, int head, int track, int sector,
             int nsects, void *buffer)
{
  union REGS r; struct SREGS s;

  r.h.ah=cmd; r.h.dl=drive; r.h.dh=head; r.h.ch=track; r.h.cl=sector;
  r.h.al=nsects; s.es=FP_SEG(buffer); r.x.bx=FP_OFF(buffer);

  int86x (0x13, &r, &r, &s);
  return (r.h.ah);
}


void ResetDrive (int unidad)
{
  union REGS r;
  r.h.ah=0; r.h.dl=unidad; int86 (0x13, &r, &r);
}


InicializaDisco (unidad, sector0, fat1)
int      unidad;
struct   boot *sector0;
unsigned char far *fat1;
{
  int error;

  ResetDrive (unidad);
  error=biosdsk (3, unidad, 0, 0, 2, sector0->SectFat, fat1);
  if (error==0)
    error=biosdsk (3, unidad, 0, 0, 1, 1, sector0);
  return (error);
}


void SonidoSube()
{
  int frec=50;

  SonidoOn();
  while (frec<5000) {
    Sonido (frec); PicoRetardo(); Sonido (frec+1000); PicoRetardo();
    frec+=10;
  }
  SonidoOff();
}


void SonidoBaja()
{
  int frec=6000;

  SonidoOn();
  while (frec>1050) {
    Sonido (frec); PicoRetardo(); Sonido (frec-1000); PicoRetardo();
    frec-=10;
  }
  SonidoOff();
}


void SonidoError()
{
  int frec1=50, frec2=6000;

  SonidoOn();
  while (frec1<5000) {
    Sonido (frec1); PicoRetardo(); Sonido (frec1+1000); PicoRetardo();
    Sonido (frec2); PicoRetardo(); Sonido (frec2-1000); PicoRetardo();
    frec1+=10; frec2-=10;
  }
  SonidoOff();
}


void SonidoOn()
{
  disable(); outportb (0x61, inportb (0x61) | 3); enable();
  outportb (0x43, 182);  /* preparar canal 2 */
}


void SonidoOff()
{
  disable(); outportb (0x61, inportb (0x61) & 0xFC); enable();
}


void Sonido (int frecuencia)
{
  unsigned periodo;

  periodo=1193180L/frecuencia;
  outportb (0x42, periodo & 0xFF);  outportb (0x42, periodo >> 8);
}


void PicoRetardo()   /* retardo de 0.5 ms en mquinas AT */
{
       asm   pushf
       asm   pop   ax
       asm   or    ah,70h
       asm   push  ax
       asm   popf
       asm   pushf
       asm   pop   ax
       asm   and   ah,0f0h
       asm   cmp   ah,0f0h     /* es PC/XT? */
       asm   je    xt
       asm   mov   cx,33       /* 181193180*33*1000 = 0.5 ms */
  wrf: asm   in    al,61h
       asm   and   al,10h
       asm   cmp   al,ah
       asm   je    wrf         /* esperar pulso refresco memoria */
       asm   mov   ah,al
       asm   loop  wrf
  xt:  asm   nop
}


int EsperarCambioDisco (int unidad)
{
  union  REGS r;  struct SREGS s;
  int    i;
  char   bf[512];

  while (kbhit()) getch();

  do {
    r.h.ah=0x16; r.h.dl=unidad; int86 (0x13, &r, &r);
  } while (!r.h.ah && !kbhit());

  if (!kbhit()) do {
    r.x.ax=0x201; r.x.cx=1; r.x.dx=unidad;
    s.es=FP_SEG(bf); r.x.bx=FP_OFF(bf); int86x (0x13, &r, &r, &s);
    r.h.ah=0x16; r.h.dl=unidad; int86 (0x13, &r, &r);
    for (i=0; i<50; i++) { delay(10); if (kbhit()) break; }
  } while (r.h.ah && !kbhit());

  if (!r.h.ah) for (i=0; i<50; i++) { delay(10); if (kbhit()) break; }

  return (kbhit()?getch()!=27:1);
}


int HablaSp()        /* devolver 1 si mensajes en castellano */
{
  union REGS r; struct SREGS s;
  char info[64];
  int i, idioma, spl[]={54, 591, 57, 506, 56, 593, 503, 34, 63, 502,
             504, 212, 52, 505, 507, 595, 51, 80, 508, 598, 58, 3, 0};

  idioma=0;  /* supuesto el ingls */

  if (_osmajor>=3) {
    r.x.ax=0x3800; s.ds=FP_SEG(info); r.x.dx=FP_OFF(info);
    intdosx (&r, &r, &s);
    i=0; while (spl[i++]) if (spl[i-1]==r.x.bx) idioma=1;
    }
  return (idioma);
}
