
; ********************************************************************
; *                                                                  *
; *  Fichero ensamblador con sector de arranque linkable con 2MF.C   *
; *                                                                  *
; *  Introducir en el fichero proyecto a '2MF.C' y '2MFBOOT.OBJ'     *
; *                                                                  *
; *  2MFBOOT.OBJ se obtiene con:  TASM /m5 /mx 2MFBOOT               *
; *                                                                  *
; ********************************************************************

_DATA          SEGMENT WORD PUBLIC 'DATA'
               ASSUME  CS:_DATA, DS:_DATA

               PUBLIC  _BootPrg, _BootPrgLong

_BootPrg:      CLI
               XOR   AX,AX
               MOV   SS,AX
               MOV   SP,7C00h          ; SS:SP inicializado
               MOV   AX,07C0h
               PUSH  AX
               PUSH  AX
               POP   DS
               POP   ES
               MOV   SI,0000h
               MOV   DI,0200h
               MOV   CX,0100h
               CLD
               REP   MOVSW             ; auto-reubicar este cdigo
               MOV   AX,07E0h
               PUSH  AX
               PUSH  AX
               PUSH  AX
               POP   DS
               POP   ES
               MOV   BX,DS:[68]        ; constante de reubicacin
               LEA   AX,[BX+OFFSET boot_ini - OFFSET _BootPrg]
               PUSH  AX
               RETF                    ; saltar a boot_ini reubicado
boot_ini:      STI
               MOV   BX,DS:[68]        ; constante de reubicacin
               PUSH  BX                ; *
               LEA   BX,[BX+OFFSET info_txt - OFFSET _BootPrg]
               CALL  print
               MOV   AH,0
               INT   16h               ; esperar por una tecla
               POP   BX                ; *
               LEA   BX,[BX+OFFSET crlf_txt - OFFSET _BootPrg]
               CALL  print
               XOR   AX,AX
               MOV   ES,AX
               MOV   BX,7C00h          ; ES:BX = 0000:7C00
               MOV   AX,0201h          ; leer un sector
               MOV   CX,0001h          ; el sector 1 del cilindro 0
               MOV   DX,0080h          ; y cabezal 0 del disco duro
               PUSH  ES
               PUSH  BX
               INT   13h               ; cargar tabla de particiones
               JNC   rd_ok
               CMP   AH,11h            ; error ECC corregido?
               JNE   err_boot
rd_ok:         CMP   WORD PTR ES:[7DFEh],0AA55h
               JNE   err_boot
               XOR   AX,AX
               MOV   DS,AX
               RETF                    ; ejecutar tabla de particiones
err_boot:      MOV   BX,DS:[68]
               LEA   BX,[BX+OFFSET noboot_txt - OFFSET _BootPrg]
               CALL  print
               MOV   AX,40h
               MOV   DS,AX
               MOV   WORD PTR DS:[72h],1234h  ; evitar chequeo memoria
               MOV   AH,0
               INT   16h                      ; esperar tecla
               DB    0EAh
               DW    0, 0FFFFh                ; jmp ffff:0000
print:         MOV   AL,[BX]
               AND   AL,AL             ; carcter 0: fin del mensaje
               JNZ   print_car
               RET
print_car:     PUSH  BX
               MOV   AH,0Eh
               MOV   BX,7
               INT   10h               ; imprimir carcter
               POP   BX
               INC   BX
               JMP   print

info_txt       DB    13,10
               DB    "Disquete 2M - Pulsa una tecla para botar del disco duro...",13,10
               DB    "2M diskette - Press any key to boot from your hard disk...",0
noboot_txt     DB    "Error! - Pulsa una tecla - Press any key...",0
crlf_txt       DB    13,10,10,0

_BootPrgLong   DW    $-OFFSET _BootPrg

_DATA          ENDS

               END
