
/*********************************************************************
*                                                                    *
*  FLOPDTR 1.1  -  Clculo de la tasa de transferencia de disquetes. *
*                       (C) 1994 Ciriaco Garca de Celis.            *
*                                                                    *
*    Para Borland C++ 2.0  superior en modelo de memoria large.     *
*                                                                    *
*********************************************************************/

#define  SMAX  63*512   /* mximo soportado: 63 sectores por pista */
#define  RD    1
#define  WR    2

#include <dos.h>
#include <alloc.h>
#include <math.h>


float tiempo()
{
   unsigned long *cbios=MK_FP(0x40, 0x6c);
   return (*cbios/18.20648);
}


int biosdsk (int cmd, int drive, int head, int track, int sector,
             int nsects, void *buffer)
{
  union REGS r; struct SREGS s;

  r.h.ah=cmd; r.h.dl=drive; r.h.dh=head; r.h.ch=track; r.h.cl=sector;
  r.h.al=nsects; s.es=FP_SEG(buffer); r.x.bx=FP_OFF(buffer);

  int86x (0x13, &r, &r, &s);
  return (r.h.ah);
}


evalua_io (operacion, buffer, unidad, cilindros, nsect, cabezales)
int operacion, unidad, cilindros, nsect, cabezales;
unsigned char far *buffer;
{
  int      cilindro, cabezal, fin_io=0, res;
  unsigned long bseg;
  float    tini, tfin;

  /* leer parte del cilindro 1 para colocar el cabezal al inicio */
  biosdsk (2, unidad, 0, 1, nsect-2, 1, buffer);

  tini=tiempo(); res=0;
  for (cilindro=1; cilindro<cilindros; cilindro++)
    for (cabezal=0; cabezal<cabezales; cabezal++) {
    if (kbhit()) if (getch()==27) goto aborta_io;
    if (res) {
      printf("\r     Fallo en el acceso a disco!.\n");
      goto aborta_io;
      }
    printf("\r\r       Cilindro %2d - Cara %d", cilindro, cabezal);
    if (operacion==WR)
        res=biosdsk (3, unidad, cabezal, cilindro, 1, nsect, buffer);
      else
        res=biosdsk (2, unidad, cabezal, cilindro, 1, nsect, buffer);
    }
  tfin=tiempo(); fin_io=1;

  bseg=(512L*nsect*(cilindros-1)*cabezales)/(tfin-tini);
  printf("\r     %7.2f segundos =%7.2f Kb/seg [%lu bits/seg]\n",
    tfin-tini, bseg/1024.0, bseg*8);
  aborta_io:
  printf("\r                                              \r");
  return (fin_io);
}


void main (int argc, char **argv)
{
  unsigned char sector0[512], far *buf;
  unsigned long dir;
  int      unidad, cilindros, sectores, cabezales;
  struct   dfree dsk;

  printf("\n FLOPDTR 1.1  -  (c) 1994 Ciriaco Garca de Celis.\n");

  if ((argc<=1) || ((unidad=(*argv[1] | 0x20)-'a')>1)) {
    printf(" - Indique la unidad A: o B: para medir su velocidad.\n");
    exit (1); }

  getdfree (unidad+1, &dsk);

  if ((long) dsk.df_total*dsk.df_sclus>65535L) {
    printf(" - Unidad de ms de 32 Mb no evaluable.\n"); exit (1); }

  if ((buf=farmalloc ((unsigned long) SMAX<<1 ))==NULL) {
    printf(" - Memoria insuficiente!.\n"); exit (2); }

  dir = ((unsigned long) FP_SEG(buf) <<4) + FP_OFF(buf);
  if ((dir>>16)!=((dir+SMAX)>>16)) buf+=SMAX;  /* por el DMA */

  biosdsk (2, unidad, 0, 0, 1, 1, sector0);
  sectores=sector0[24]+256*sector0[25]; cabezales=sector0[26];
  cilindros=(sector0[19]+256*sector0[20])/sectores/cabezales;

  if (sectores>63) {
    printf(" - No soportados mms de 63 sectores/pista!.\n");
    exit (3); }

  printf(" - Clculo de la tasa de transferencia BIOS a disquete.\n");

  printf("   + Rendimiento en lectura:\n");
  if (evalua_io (RD, buf, unidad, cilindros, sectores, cabezales)) {
    if (dsk.df_avail < dsk.df_total) {
      printf("   + Disquete no vaco -> sin test de escritura.\n");
      exit (1);
      }
    printf("   + Rendimiento en escritura:\n");
    evalua_io (WR, buf, unidad, cilindros, sectores, cabezales);
    }
}
